#include <jni.h>
#include "ActiveSend.h"

#include <errno.h>
#include <stdlib.h>
#include <sys/uio.h>

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <netinet/ip.h>
#include <netinet/tcp.h>


#define IP_OPTIONS_SIZE 44

int S;
char optionsBuffer[IP_OPTIONS_SIZE];
//char *maddr;
struct sockaddr_in servAddr;
char buf [3655];

JNIEXPORT void JNICALL 

Java_ActiveSend_init_1socket (JNIEnv *env, jobject jobj, jstring mcast_addr, jint port)
{ 
  struct hostent *h;
  struct sockaddr_in  cliAddr;
  unsigned char ttl = 128;
  int iret;
  socklen_t len;
  char *pBuf;
  

  char *maddr = (char *)(*env)->GetStringUTFChars(env,mcast_addr, 0);

  //printf("Connecting to %s",maddr);
  
  h = gethostbyname (maddr);
  
  /*Verifier l'exactitude de l'adresse IP*/

  if (h==NULL)
    {printf("%s: Unknow host\n",*maddr);
     exit (1);
    }

  servAddr.sin_family = h->h_addrtype;
  memcpy((char *) &servAddr.sin_addr.s_addr, h->h_addr_list[0],h->h_length);
  servAddr.sin_port =htons(port);

  /*Verifier que l'adresse IP est multicast*/

  if(!IN_MULTICAST(ntohl(servAddr.sin_addr.s_addr)))
     { printf("%s: is not  multicast\n", maddr);
       exit(1);
       }

  /*Creer la socket*/

  S = socket (AF_INET,SOCK_DGRAM,0);

  if (S<0)
    { printf("cannot open socket\n");
     exit(1);
    }

  cliAddr.sin_family = AF_INET;
  cliAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  cliAddr.sin_port =htons (0);

  if (bind(S,(struct sockaddr *) &cliAddr, sizeof(cliAddr))<0)
    { printf("cannot bind socket\n");
      exit(1);
    }

  /*mettre le ttl en place*/

  if (setsockopt(S,IPPROTO_IP,IP_MULTICAST_TTL,&ttl,sizeof(ttl))<0)
    { printf("cannot set ttl\n");
      exit(1);
      }

  memset (optionsBuffer, IPOPT_END,IP_OPTIONS_SIZE);
  len = IP_OPTIONS_SIZE;

  iret = getsockopt (S,IPPROTO_IP,IP_OPTIONS,(void *)optionsBuffer, &len);

  pBuf = optionsBuffer;
  while (*pBuf != IPOPT_END) pBuf++;

  *pBuf = IPOPT_RA;
  pBuf++;

  *pBuf = 4 ;
  pBuf++;

  *pBuf = 0;
  pBuf++;

  *pBuf = 0;
  pBuf++;
  
  len = len+4;

  while (len&3)
    len++;

  if(len>IP_OPTIONS_SIZE)
    len = IP_OPTIONS_SIZE;

  iret = setsockopt (S,IPPROTO_IP,IP_OPTIONS,(void *)optionsBuffer, len);

  if (iret!=0)
    { printf("cannot set bit Router Alert\n");
      exit(1);
      }

  /*iret = connect (S,(struct sockaddr *)&servAddr,sizeof(servAddr));

  if (iret!=0)
    { printf("cannot connect socket\n");
      exit(1);
      }*/
  

  //printf ("Socket Multicast initialisee\n");
  
  return ;

}

JNIEXPORT void JNICALL
 

Java_ActiveSend_write  (JNIEnv *env, jobject jobj, jbyteArray jba, jint len)
{ 
  int i=0;

  /*if (&env==NULL)
  printf("C'est env");*/

  jsize mlen = (*env)->GetArrayLength(env,jba);
  jbyte *body = (*env)->GetByteArrayElements(env,jba,0);

   for (i=0;i<len;i++)
   buf[i]=body[i];
    
  
   
  
 
   if ((len==0)||(sendto(S,buf,len, 0, (struct sockaddr *)&servAddr, sizeof(servAddr)) == -1))
   err("write");



  /*if ((write(S,buf,mlen))==-1)
    { printf("cannot write data\n");
      exit(1);
      }*/


  //printf("paquet emis taille=%d \n",len);
  

  // if (close(S) == -1) 
  //err("close");



  //printf("au revoir!\n");
    return;
}








