

import java.net.*;
import java.io.*;

public class Receive_send extends Thread
{
    static final String VERSION = "0.1";

    static final boolean DBG = true;

    static final double INFINITE = 9999999L;
    
    static String serviceName = "MultiCastS"; //default service

    static String serviceBroker = "http://140.77.15.124"; 
    static int delay = 500; // default delay (ms) between each sent packet
    static int timeout = 1000; // default time out
    static boolean infiniteLoop = true;

    static String proxyTAN = null;
    static int proxyTANport = 5432; // default port
    static int serverPort = 5432;   // default port

    static int proto = TANet.UDP; // default protocol is UDP
    static String destId = null;
    static long seq=0; // numero de sequence du paquet manquant
    static int nbrPingPackets = 0;

    byte [] srvNameinBytes;
    byte [] srcIdinBytes  ;   
    byte [] destIdinBytes ;   
    byte [] lastIdinBytes ;   
    byte [] proxyTANIdinBytes;

    static int payloadSize = 4*1024; // default payload size (Bytes)
    static byte [] payload ;
    static String recepteurOriginal = ""; // contient l`ip du recepteur 
    static int repair=0; //= 0: data normal, 1: renvoi d'un paquet
    static boolean R=false; // on est donc par defaut en emission  	
  
    
    TANet net;

    Receive_send()
    {
    } 

    static void usage ()
    {
	System.out.println( "Receive_send - v " + VERSION );
	System.out.println( "------------------------");
	System.out.println( "Usage : Receive_send [-h] [-size s] [-R/S] [-delay d] "+
			    "[-port p] [-to timeout]");
	System.out.println( "        [-udp | -tcp] [-n nbr] -tan proxyTAN "+
			    "[-t target]");
	System.out.println( "");
	System.out.println( "");
	System.out.println( "  -h       : this help");
	System.out.println( "  -tan t   : this host must be connected to "+
			    "a proxyTAN");
	System.out.println( "  -t target:  packets are sent towards "+
			    "target");
	System.out.println( "  -size s  : payload size of ANEP packets");
	System.out.println( "  -delay d : delay (ms) between each ping "+
			    "packet");
	System.out.println( "  -port p  : send data on port p of proxyTAN");
	System.out.println( "  -dp bool : send data paquet bool=1 for repair");
	System.out.println( "  -R       : receive mode (default)");
	System.out.println( "  -S       : send mode");
	System.out.println();
    } // usage()
  
    static void parseArgs ( String[]args )
    {
	if(args.length == 0) {
	    usage ();
	    System.exit (1);
	}
	int i;
	for (i = 0; i < args.length; i++)
	    {
		if (args[i].equals ("--help") || args[i].equals ("-h"))
		    {		
			usage ();
			System.exit (1);
		    }
		else if (args[i].equals ("-size"))
		    {		
			i++;
			payloadSize = Integer.parseInt(args[i]);
		    }
		else if (args[i].equals ("-delay"))
		    {		
			i++;
			delay = Integer.parseInt(args[i]);
		    }
		else if (args[i].equals ("-port"))
		    {		
			i++;
			proxyTANport = Integer.parseInt(args[i]);
		    }

		else if (args[i].equals ("-tan"))
		    {		
			i++;
			proxyTAN = args[i];
		    }

		else if (args[i].equals ("-to"))
		    {		
			i++;
			timeout = Integer.parseInt(args[i]);;
		    }
		else if (args[i].equals ("-n"))
                    {
                        i++;
                        nbrPingPackets = Integer.parseInt(args[i]);
                    }
		else if (args[i].equals ("-t"))
		    {		
			i++;
			destId = args[i];
		    }
		else if (args[i].equals ("-R"))
		    {		
			i++;
			R = true;
		    }
		else if (args[i].equals ("-S"))
		    {		
			i++;
			R = false;
		    }
		else
		    {
			System.out.println ("Invalid argument : " + args[i]);
			usage ();
			System.exit (1);
		    }
	    }
    } // parseArgs()

    public static void displayOptions()
    {
	System.out.println ("Service Name   : " + serviceName );
	System.out.println ("Service Broker : " + serviceBroker );
	System.out.println ("Delay          : " + delay );
	System.out.println ("proxy TAN      : " + proxyTAN );
	System.out.println ("port  TAN      : " + proxyTANport );
	System.out.println ("target         : " + destId);
        System.out.print   ("Protocole      : " );
	switch(proto) {
	case TANet.UDP : System.out.println("UDP"); break;
	case TANet.TCP : System.out.println("TCP"); break;
	default : System.out.println( "unknown" );
	}
	System.out.println ("Payload size : " + payloadSize);
	System.out.println ("Timeout (ms) : " + timeout);
    }




    public void run()
    {
	// Connect this thread to the closest proxyTAN
	// (given by arguments -tan hostname)
	switch(proto) {
        case TANet.TCP:
	    net = new TANet( TANet.TCP, proxyTAN, proxyTANport, timeout );
	    break;
	
	case TANet.UDP:
	    net = new TANet( TANet.UDP, proxyTAN, proxyTANport, timeout );
	    break;
	}
	
	// and finally start threads

	Reception recep = new Reception
	(net,delay,payloadSize,nbrPingPackets,destId,recepteurOriginal,repair, proxyTAN);	
	recep.start(); // start thread
	if(DBG) System.out.println("Reception : run() Reception thread done.");
		
 
	if (!R) {
		Emission emi = new Emission (net,delay,payloadSize,nbrPingPackets, recepteurOriginal, repair, proxyTAN);
		emi.start(); // start thread
		if(DBG) System.out.println("Emission : run() Emission thread done.");
	}
	
	
    } // run()
	

    public static void main( String [] args ) 
    {
	parseArgs( args );
	if(proxyTAN == null) {
	    usage (); System.exit (1);
	}

	Receive_send rs = new Receive_send();
	rs.start(); // start thread

    } // main()
}

