import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.util.Calendar;
import java.text.DateFormat;


public class Multicast_Recv extends Thread {

     File f =null;    static NVector nackCache;
     Client client;
     String emetteur=null;
     StreamStruct stream;
     MulticastSocket mrs; 
     Indicator indicator;
     Unicast_Recv ur;
     int N = 0; 
     String pere = null;
     long start_time = 0;
     long end_time   = 0; 
     int first =0;
     LOClient loclient;
     long MAXSEQ;
     
    
      

    public Multicast_Recv (String Multicast_address, String recvFileName)throws UnknownHostException, SocketException,FileNotFoundException,IOException
      
    {
	InetAddress multicast_address;
	multicast_address = InetAddress.getByName (Multicast_address);
	
        mrs = new MulticastSocket (4000);
	mrs.joinGroup(multicast_address);
	mrs.setSoTimeout(750);
	

	f = new File(recvFileName);
	stream = new StreamStruct(f,false);// C une structure de recepteur
	this.nackCache = new NVector(); // notre cache des Nacks emis (sans reponse biensure)
	this.client = new Client ();
	this.indicator = new Indicator (stream);
	this.ur = new Unicast_Recv(this,stream);
	this.loclient = new LOClient();
	
      }
	  

    public void start ()
     { 
       indicator.start();
       ur.start();
       super.start();
       
     }

    
    
    public void PktOrder () throws IOException  
    {
	int i = 0;
	DCacheControl pkt;
	
	while (i<stream.dcache.size())
	    { pkt = (DCacheControl) stream.dcache.elementAt(i);
	    
	      if ((pkt.seq==stream.lo+1)&&(pkt.anepkt!=null))
		  {
		   notifyNewPacket (pkt.anepkt);
		   stream.lo++;
		   //dataStream.rfwrite(pkt.seq);
		   pkt.packetDeliveredToApplication=true;
		   i=0;/*reprendre le teste du debut*/
		  }
	      else
		  i++;  
	    }
    
    }	

    

    


    protected void notifyNewPacket (ANEPacket anepkt) throws IOException  
    {
	NewPacketEvent evt = new NewPacketEvent(this,anepkt); 
	NewPacketListener listener = (NewPacketListener) this.client;
        listener.NewPacket(evt,stream);
    }




   public int findPkt (long seq)
    {
	DCacheControl pkt;
	int index = -1;

	for (int i=0;i<stream.dcache.size();i++)
	    { 
	      pkt = (DCacheControl) stream.dcache.elementAt(i);
	      
	      if (pkt.seq==seq)
		  { index = i ;
		    break;
		  }
	    }

	return (index);

    }


   public void InitReqHandler (ANEPacket anepkt) throws IOException, BadANEPversionException 
    { TANet net = new TANet ();
      net.anepkt=anepkt;
      net.recoverInfoFromANEPkt ();
      System.out.println("la session est initialisee");
      ur.usend.SendInit_Resp(net.srcId);
      pere = net.srcId;  
    }

  protected void notifyNewLO (long lo) throws IOException  
    {
	NewLOEvent evt = new NewLOEvent(this,lo); 
	NewLOListener listener = (NewLOListener) this.loclient;
        listener.NewLO(evt,stream);
    }

    
 public void dataPktHandler (ANEPacket anepkt) throws IOException, BadANEPversionException
     {   
	
	int type = 0 ;
	long seq = 0 ;
	long maxseq = 0;
	long rate = 0;
	int repair  = 0;
	long file_size = 0;
	int bytesread = 0;
	int index = 0 ;
        DCacheControl pkt;
	NCacheControl nack;
	TANet net = new TANet ();
	

        ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
	DataInputStream dis = new DataInputStream( bais );
	
	type=dis.readInt();
	repair = dis.readInt();
	seq=dis.readLong();
	maxseq = dis.readLong();
	rate   = dis.readLong();
	bytesread= dis.readInt();
	file_size= dis.readLong();

	if((stream.file_size<=0)&&(file_size>0)&&(repair==0))
	{stream.file_size = file_size;
	 MAXSEQ= (long) file_size/1000 + 1;
	 }

	N++;

	if (N==32)
	{ /*On renvoie un CR et on remet le compteur a 0 */
	   N=0;
	   notifyNewLO(stream.lo);
	   ur.usend.SendCR(stream.emetteur,stream.lo,stream.lr,stream.maxseq);
	}

	
	net.anepkt=anepkt;
	net.recoverInfoFromANEPkt ();
	
	
	if ((stream.emetteur==null)&&(net.srcId!=null))
	    {stream.emetteur= net.srcId;
	    //System.out.println("Source="+net.srcId);
	    }


	/*suprimer le timer du Nack correspondant au paquet recue*/

	
	 for (int i=0;i<stream.nackCache.size();i++)
	    {  
	       
	       nack = (NCacheControl) stream.nackCache.elementAt(i);
		          
	       if (nack.seq == seq)
	       { nack.received=true;
		 stream.nackCache.removeElementAt(i);
		 break;
		 //dataStream.nrwrite(seq);
	       }
	     }


	if (seq>stream.lo)
        {  pkt = new DCacheControl(seq , anepkt);
	   index = findPkt(seq);

	   if (index==-1) // on a un nouveau paquet
	     { 
		 /*mettre le paquet ANEP dans le buffer*/
		 //dataStream.rwrite(seq);
	         stream.dcache.addElement( pkt);

	     }
	    

	    if (seq==stream.lo+1)
	     { //declencher un evt NewPacket pour le mettre dans le fichier
	       notifyNewPacket (pkt.anepkt);
	       stream.lo++;
	       
	       //dataStream.fwrite(seq);
	       pkt.packetDeliveredToApplication=true;
	       
	       //Verifier l'ordre des autres paquets dans le buffer
	       PktOrder();
	     }

	     /*mettre a jour le minseq*/
	     if (stream.minseq==0)
		    stream.minseq = seq;
	     else
		if(seq<stream.minseq)
		    stream.minseq = seq;


	     /*mettre a jour le maxseq*/
	     if (stream.maxseq==0)
		 stream.maxseq = seq;
	     else
		 if(seq<stream.maxseq)
		      stream.maxseq = seq;


	     /*mettre a jour le lr*/
	      if (stream.lr==0)
		 stream.lr = seq;
	      else
		if(seq<stream.lr)
		 stream.lr = seq;


	    /*mettre a jour le next */     
	      if (seq==stream.next)
		{  if (MAXSEQ>0)
		    { if (stream.next<MAXSEQ)
			stream.next++;
		    }
		   else
		      stream.next++;
		
		}

	     /*mettre les paquet en retard ou perdue dans le nackCache*/
	     if (seq>stream.next)
	     { 
		 for (long j=stream.next;j<seq;j++)
		  { nack = new NCacheControl(j,emetteur);
		    stream.nackCache.addElement(nack);
		    ur.usend.SendNack(stream.emetteur,j,stream.lo,stream.lr,stream.maxseq);
		    System.out.println("packet("+j+") is lost");
		  }
			 
	         stream.next = seq+1;
	     }

                  
		     
         }



    }


   
    public void receiveDataPacket () throws IOException, BadANEPversionException,SocketException
     {
        
        ANEPacket anepkt;
	int type=0;
        NCacheControl nack;
	TANet net = new TANet ();
	byte [] buffer= new byte [4000];
	DatagramPacket dp=new DatagramPacket(buffer, buffer.length);

	try{ 
	      mrs.receive(dp);
	      
	      anepkt=ANEPacket.unmarshall(dp.getData());
	      net.anepkt=anepkt;
	      net.recoverInfoFromANEPkt ();
	      ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
	      DataInputStream dis = new DataInputStream( bais );
	      type = dis.readInt();
	      
	      
	      if (type==0)
	       { dataPktHandler (anepkt);
	         if (first==0)
		     { first = 1;
		       Calendar calendar = Calendar.getInstance();
		       start_time = calendar.getTimeInMillis();
		     }
	       } 
		
	      if (type==3)
		  InitReqHandler(anepkt); 
	      
	   } catch(SocketTimeoutException e)
	      {
	       if ((stream.next>1)&& (!stream.Complete()))
	       {nack = new NCacheControl(stream.next,emetteur);
		nackCache.addElement(nack);
		ur.usend.SendNack(stream.emetteur,stream.next,stream.lo,stream.lr,stream.maxseq);
		System.out.println("packet("+stream.next+") is too late");
               }
	      }
         

  }

  
   
 public void run ()  
   {
	   
       

    try {
	 while (!stream.Complete())
	      receiveDataPacket ();
	      
	}catch (IOException e){ System.out.println (e);
	  }catch (BadANEPversionException  e) { System.out.println (e);}
	                
     Calendar calendar2 = Calendar.getInstance();
     end_time = calendar2.getTimeInMillis();
     long elapsed_time = end_time - start_time;
     //elapsed_time = elapsed_time/1000;
     System.out.println("Elapsed Time="+elapsed_time);
    
    
   }	



}









