/* gcc client.c -o client */

#include <errno.h>
#include <stdlib.h>
#include <sys/uio.h>

#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>

#include <netinet/ip.h>
#include <netinet/tcp.h>

#define IP_OPTIONS_SIZE 44

char optionsBuffer[IP_OPTIONS_SIZE];
char *pBuf;
socklen_t len; 
int iret;

int sock;
struct sockaddr_in sa;
struct hostent *hp;
u_long toaddr;
char buf[1024];


main(int argc, char **argv) {


  if (argc < 3) {
    printf("usage: %s host port\n", argv[0]);
    printf("Emet un paquet UDP avec l'option IP Router Alert active, puis attend le retour du paquet.\n");
    printf("ex: ./client localhost 7\n");
    
    exit(1);
  }
  sa.sin_family = AF_INET;
  hp = gethostbyname(argv[1]);
  if (hp == NULL) {
    printf("gethostbyname problem\n");
    exit(1);
  }
  //bcopy(hp->h_addr,&sa.sin_addr,hp->h_length);
  toaddr = *(u_long *) hp->h_addr_list[0]; 
  sa.sin_addr.s_addr = toaddr;
  sa.sin_port = htons(atoi(argv[2]));

  sprintf(buf, "La la la la\n");

  sock = socket(PF_INET, SOCK_DGRAM, 0);
  if (sock == -1) err("socket");     

  if (connect(sock, (struct sockaddr*)&sa, sizeof(sa)) == -1) 
    err("connect");

  /********************************************************************/
  /* Set the Router Alert field                                       */
  /********************************************************************/
  //Get the previous value
  memset(optionsBuffer, IPOPT_END, IP_OPTIONS_SIZE);
  len = IP_OPTIONS_SIZE;
  
  iret = getsockopt(sock, IPPROTO_IP, IP_OPTIONS, (void *)optionsBuffer, 
		    &len); 
  
  pBuf = optionsBuffer;
  while ( *pBuf != IPOPT_END ) pBuf++;
  
  *pBuf = IPOPT_RA; //Option copy-class-number
  pBuf++;
  *pBuf = 4;        //Option length
  pBuf++;
  *pBuf = 0;        //Option data, cf ip_options.c
  pBuf++;
  *pBuf = 0;        //Option data, cf ip_options.c
  pBuf++;
  
  len = len + 4;

  while ( len & 3 )
    len++; //Align on 32bits boundary
  
  if ( len > IP_OPTIONS_SIZE )
    len = IP_OPTIONS_SIZE;
  
  iret = setsockopt(sock, IPPROTO_IP, IP_OPTIONS, 
		    (void *)optionsBuffer, len);

  if ( iret != 0 )
    {
      printf("Probleme lors de l'activation du champ IP Router Alert\n");
    }

/********************************************************************/


  printf("send: %s", buf);
  if (sendto(sock,buf,strlen(buf), 0, (struct sockaddr *)&sa, sizeof(sa)) == -1)
    err("write");

  if (close(sock) == -1) 
    err("close");

  printf("done !\n");
}
